""" aufgabe_ls2_08 - Druckerverwaltung
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  05.10.2023, 09.10.2023
    """

import csv

DATEI_NAME = "druckerverwaltung.csv"

# Druckerdaten aus CSV-Datei einlesen
drucker_liste = []
eingabe_datei = open(DATEI_NAME, "r", encoding="utf-8")
csv_eingabe_objekt = csv.reader(eingabe_datei)
for zeile in csv_eingabe_objekt:
    drucker = {"ID": zeile[0], "Hersteller": zeile[1], "Modell": zeile[2]}
    drucker_liste.append(drucker)
eingabe_datei.close()

# Arbeitsschleife
while True:
    # Menü und Befehlsauswahl
    print("Fingerübung Druckerverwaltung")
    print("-----------------------------")
    print("")
    print("1 - Neuen Drucker anlegen")
    print("2 - Druckerdaten ändern")
    print("3 - Drucker löschen")
    print("4 - Alle Drucker anzeigen")
    print("0 - Programm beenden")
    befehl = int(input("Auswahl: "))
    print("")

    if befehl == 0:
        # Schleife verlassen und Programm beenden
        break
    elif befehl == 1:
        # Neuen Drucker anlegen
        identifier = input("ID: ")
        hersteller = input("Hersteller: ")
        modell = input("Modell: ")
        drucker = {"ID": identifier, "Hersteller": hersteller, "Modell": modell}
        drucker_liste.append(drucker)
        print("")
    elif befehl == 2:
        # Druckerdaten ändern
        identifier = input("ID: ")
        gefunden = False
        i = 0
        while i < len(drucker_liste):
            drucker = drucker_liste[i]
            if drucker["ID"] == identifier:
                gefunden = True
                break
            i = i + 1
        if gefunden is False:
            print("Kein Drucker mit der ID vorhanden")
        else:
            hersteller = input("Hersteller:")
            modell = input("Modell:")
            drucker_aktualisiert = {"ID": identifier, "Hersteller": hersteller, "Modell": modell}
            drucker_liste[i] = drucker_aktualisiert
        print("")
    elif befehl == 3:
        # Drucker löschen
        identifier = input("ID:")
        gefunden = False
        i = 0
        while i < len(drucker_liste):
            drucker = drucker_liste[i]
            if drucker["ID"] == identifier:
                gefunden = True
                break
            i = i + 1
        if gefunden is False:
            print("Kein Drucker mit der ID vorhanden")
        else:
            del drucker_liste[i]
            print("Drucker mit der ID gelöscht")
        print("")
    elif befehl == 4:
        # Alle Drucker anzeigen
        print("Druckerliste")
        print("------------")
        print("")
        for drucker in drucker_liste:
            for schluessel, wert in drucker.items():
                print(schluessel, ":", wert)
            print("")
    else:
        # Falsche Befehlseingabe
        print("!!! Unbekannter Befehl:", befehl)
        print("")

# Druckerdaten in CSV-Datei speichern
ausgabe_datei = open(DATEI_NAME, "w", encoding="utf-8", newline="")
csv_ausgabe_objekt = csv.writer(ausgabe_datei)
for drucker in drucker_liste:
    zeile = []
    for wert in drucker.values():
        zeile.append(wert)
    csv_ausgabe_objekt.writerow(zeile)
ausgabe_datei.close()
