""" pfsa_19.py - Netzwerkrechner
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  12.11.2023
    """


import ipaddress


def binaer_umwandeln(iptext):
    """IP4-Adresse binär darstellen"""
    zahlen = iptext.split(".")
    binaer = f"{int(zahlen[0]):08b}.{int(zahlen[1]):08b}.{int(zahlen[2]):08b}.{int(zahlen[3]):08b}"
    return binaer


print("Netzwerkrechner")
print("---------------")
print("")

eingabe_host_adresse = input("Host IP-Adresse (V4): ")
eingabe_cidr = input("CIDR-Suffix:          ")
print("")

eingabe_netz = eingabe_host_adresse + "/" + eingabe_cidr
ip4_adresse = ipaddress.ip_address(eingabe_host_adresse)
ip4_netz = ipaddress.ip_network(eingabe_netz, strict=False)

adressierbare_hosts = ip4_netz.num_addresses - 2
suffixlaenge = ip4_netz.prefixlen
netmaske = ip4_netz.netmask
netzmaske_binaer = binaer_umwandeln(str(netmaske))
hostmaske = ip4_netz.hostmask
hostmaske_binaer = binaer_umwandeln(str(hostmaske))
broadcast_adresse = ip4_netz.broadcast_address
host_liste = list(ip4_netz.hosts())
erste_hostid = host_liste[0]
letzte_hostid = host_liste[-1]

print("Netzdaten:")
print("----------")
print("")
print("Netzadresse:        ", ip4_netz)
print("CIDR-Suffix:        ", suffixlaenge)
print(f"Netzmaske:           {netmaske:<15s} -> {netzmaske_binaer:35s}")
print(f"Hostmaske:           {hostmaske:<15s} -> {hostmaske_binaer:35s}")
print("Adressierbare Hosts:", adressierbare_hosts)
print("Broadcastadresse:   ", broadcast_adresse)
print(f"Host-IPs:            von: {erste_hostid}   bis: {letzte_hostid}")
